SystemOrganization addCategory: 'OrbeonFormProcessWeb2'!

SewafLateralListComposite subclass: #WAOrbeonProcessBrowser
	instanceVariableNames: 'seasideK mode categories transitionsHeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcessWeb2'!

WAOrbeonProcessBrowser subclass: #WAEmbeddedProcessBrowser
	instanceVariableNames: 'orbeonFrame orbeonIsOnPage isEditMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcessWeb2'!

!WAEmbeddedProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/02/2015 15:22'!
hasIFrame

	^orbeonFrame notNil! !

!WAEmbeddedProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/02/2015 15:22'!
initialize

	super initialize.

	orbeonIsOnPage := false.
	isEditMode := false.! !

!WAEmbeddedProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 06/02/2015 15:22'!
isEditMode
	^isEditMode! !

!WAEmbeddedProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 06/02/2015 15:22'!
isEditMode: newValue
	isEditMode := newValue! !

!WAEmbeddedProcessBrowser methodsFor: 'orbeon links' stamp: 'BrunoBB 06/02/2015 15:22'!
linkToOrbeonFormFor: anOrbeonFormTransition
	"The receiver gives the control to Orbeon Java application."
	| uuid |

	uuid  := OrbeonTempServiceRegistry default 
					createEntryToOrbeonFor: anOrbeonFormTransition 
					for: self session user.

	orbeonFrame := self getUrlFor: anOrbeonFormTransition with: uuid.! !

!WAEmbeddedProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 06/02/2015 15:22'!
orbeonFrame
	^orbeonFrame! !

!WAEmbeddedProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 06/02/2015 15:22'!
orbeonFrame: newValue
	orbeonFrame := newValue! !

!WAEmbeddedProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 06/02/2015 15:22'!
orbeonIsOnPage
	^orbeonIsOnPage! !

!WAEmbeddedProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 06/02/2015 15:22'!
orbeonIsOnPage: newValue
	orbeonIsOnPage := newValue! !

!WAEmbeddedProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 07/01/2015 12:32'!
renderContentOn: html
	| widthClass |

	seasideK := self requestContext request at: '_k' ifAbsent: ['error'].

	self hasIFrame ifFalse: [^super renderContentOn: html].

	html div id: 'top-search-area'; with: [self renderSearchAreaOn: html.].

	showLateralList ifTrue: [
		html div id: 'lateral-assignment-list'; with: [self renderLateralListOn: html]].

	widthClass := showLateralList ifFalse: ['process-assignment-width100'] ifTrue: ['process-assignment-width80'].
	
	html div id: 'process-assignment'; class: widthClass;
		with: [self renderEmbeddedProcessAssignmentOn: html.
				self renderContentWithFrameOn: html].! !

!WAEmbeddedProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/27/2015 14:59'!
renderContentWithFrameOn: html

	html div id: 'close-form-frame'; 
		with: [html anchor callback: [orbeonFrame := nil]; 
			with: [html image url: (SEWAFIconLibrary / #symboldeleteiconPng);
													title: ('Close Form' translateFor: self session user);
													altText: ('Close Form' translateFor: self session user)]].
	html div id: 'orbeon-form-frame'; 
		with: [html div id: 'orbeon-form'; with: [html iframe url: orbeonFrame]].! !

!WAEmbeddedProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/27/2015 14:58'!
renderEmbeddedProcessAssignmentOn: html

	selectedLateralItem ifNil: [^self].

	html div id: 'process-assignment-description'; 
		with: [self renderItemDescriptionOn: html.].

	html horizontalRule.! !

WAOrbeonProcessBrowser subclass: #WALinkedProcessBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcessWeb2'!

!WALinkedProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 10/03/2015 16:24'!
linkToOrbeonFormFor: anOrbeonFormTransition
	"The receiver gives the control to Orbeon Java application."
	| uuid |

	uuid  := OrbeonTempServiceRegistry default 
					createEntryToOrbeonFor: anOrbeonFormTransition 
					for: self session user.

	^self requestContext redirectTo: (self getUrlFor: anOrbeonFormTransition with: uuid).! !

!WAOrbeonProcessBrowser methodsFor: 'orbeon links' stamp: 'BrunoBB 10/22/2015 16:17'!
buildEditUrlFor: anOrbeonFormTransition with: anUUID
	"Answer a string Link to EDIT the Orbeon Form associated with the transition <anOrbeonFormTransition> using the security token <anUUID>"
	| formDefinition |

	formDefinition := anOrbeonFormTransition endFormName.

	^OrbeonServerConfiguration default orbeonIP,'/orbeon/fr/', anOrbeonFormTransition applicationName ,'/',formDefinition,'/edit/', anOrbeonFormTransition getOrbeonFormId,'?token=', anUUID,'&s=', self session key,'&k=', seasideK, '&oop=', anOrbeonFormTransition asOop printString, '&oop2=', selectedLateralItem asOop printString! !

!WAOrbeonProcessBrowser methodsFor: 'orbeon links' stamp: 'BrunoBB 10/22/2015 16:17'!
buildNewUrlFor: anOrbeonFormTransition with: anUUID
	"Answer a string Link to NEW Orbeon Form associated with the transition <anOrbeonFormTransition> using the security token <anUUID>"
	| formDefinition |

	formDefinition := anOrbeonFormTransition endFormName.

	^OrbeonServerConfiguration default orbeonIP, '/orbeon/fr/', anOrbeonFormTransition applicationName ,'/',formDefinition, '/new?token=', anUUID,'&s=', self session key,'&k=', seasideK, '&oop=', anOrbeonFormTransition asOop printString, '&oop2=', selectedLateralItem asOop printString! !

!WAOrbeonProcessBrowser methodsFor: 'orbeon links' stamp: 'BrunoBB 10/22/2015 16:17'!
buildPDFUrlFor: anOrbeonFormTransition with: anUUID
	"Answer a string Link to PDF the Orbeon Form associated with the transition <anOrbeonFormTransition> using the security token <anUUID>"
	| formDefinition |

	formDefinition := anOrbeonFormTransition endFormName.

	^OrbeonServerConfiguration default orbeonIP,'/orbeon/fr/', anOrbeonFormTransition applicationName ,'/',formDefinition,'/pdf/', anOrbeonFormTransition getOrbeonFormId,'?token=', anUUID,'&s=', self session key,'&k=', seasideK, '&oop=', anOrbeonFormTransition asOop printString, '&oop2=', selectedLateralItem asOop printString! !

!WAOrbeonProcessBrowser methodsFor: 'orbeon links' stamp: 'BrunoBB 10/22/2015 16:17'!
buildViewUrlFor: anOrbeonFormTransition with: anUUID
	"Answer a string Link to VIEW the Orbeon Form associated with the transition <anOrbeonFormTransition> using the security token <anUUID>"
	| formDefinition |

	formDefinition := anOrbeonFormTransition endFormName.

	^OrbeonServerConfiguration default orbeonIP,'/orbeon/fr/', anOrbeonFormTransition applicationName ,'/',formDefinition,'/view/', anOrbeonFormTransition getOrbeonFormId,'?token=', anUUID,'&s=', self session key,'&k=', seasideK, '&oop=', anOrbeonFormTransition asOop printString, '&oop2=', selectedLateralItem asOop printString! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 10/22/2015 16:17'!
closeAndSendForm: anOrbeonFormTransition
	"After filling the form the user has clicked on close and send.
	The form can not be edited again."

	anOrbeonFormTransition finalize.
	
	anOrbeonFormTransition generateNextRunningTransitions.! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 10/22/2015 18:29'!
collapseIconFor: anOrbeonFormTransition

	((transitionsHeight includesKey: anOrbeonFormTransition) and: [(transitionsHeight at: anOrbeonFormTransition) = #collapsed])
	ifTrue: [^#circledown16Png].

	^#circleup16Png! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 10/22/2015 18:53'!
collapseTitleFor: anOrbeonFormTransition

	((transitionsHeight includesKey: anOrbeonFormTransition) and: [(transitionsHeight at: anOrbeonFormTransition) = #expanded]) 
	ifFalse: [^'Expand' translateFor: self session user].

	^'Collapse' translateFor: self session user! !

!WAOrbeonProcessBrowser methodsFor: 'orbeon links' stamp: 'BrunoBB 10/22/2015 16:17'!
createOrbeonLinkOn: html for: anOrbeonFormTransition

	html anchor callback: [self linkToOrbeonFormFor: anOrbeonFormTransition]; 
						with: [html image url: (SEWAFIconLibrary / (self iconFor: anOrbeonFormTransition));
													title: (self imageTitleFor: anOrbeonFormTransition);
													altText: (self imageTitleFor: anOrbeonFormTransition)].


	(anOrbeonFormTransition hasForm and:[(anOrbeonFormTransition isGrantedUser: self session user)])
	ifTrue: [ html anchor callback: [self linkToOrbeonPdfFor: anOrbeonFormTransition];
							target: '_blank'; "open the PDF in a new tab or page"
							with: [html image url: (SEWAFIconLibrary / #pdf32Png);
														title: ('View PDF' translateFor: self session user);
														altText: ('View PDF' translateFor: self session user)].
	]

	"if the transition is done and has expected results --> we render an icon to show results summary"

"	(anOrbeonFormTransition isDone and:[anOrbeonFormTransition hasExpectedResult])
	ifTrue: [self renderExpectedResultIcon: html for: anOrbeonFormTransition]"! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 11/05/2015 13:32'!
displayModeFor: anOrbeonFormTransition

	^transitionsHeight at: anOrbeonFormTransition ifAbsent: [#expanded]! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 10/22/2015 16:17'!
downloadProcessMap
	| stream contents |

	stream := PrintStream on: String new.

	stream nextPutAll: self selectedLateralItem formProcess generateProcessMap prettyPrinted.

	self requestContext respond: [:response | 
        response document: ((stream contents asByteArray seasideMimeDocument) 
                                        mimeType: 'application/csv'; 
                                        fileName: (self selectedLateralItem formProcess name, '.xpdl'); 
                                        yourself)].! !

!WAOrbeonProcessBrowser methodsFor: 'categories' stamp: 'BrunoBB 10/22/2015 16:17'!
filterProcessDefinitionByCategory: aProcessDefinitionUserCategory

	searchApplied := true.
	searchResult := self getIterationCollection select: [:each | aProcessDefinitionUserCategory includes: each]! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 10/22/2015 16:17'!
freeSelectedProcess

	self session user untake: selectedLateralItem! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 10/22/2015 16:17'!
getAllAssignmentsFor: procName in: appName
	"Answer a collection of <OrbeonProcessAssignment> for the process named <procName> in application <appName>"
	| selectBlock |

	selectBlock := (procName = self viewAllText)
		ifTrue: [[:each | each applicationName = appName]]
		ifFalse: [[:each | each applicationName = appName and: [each processName = procName]]].

	searchResult := self getIterationCollection select: selectBlock! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 13:24'!
getAllTransitions

	selectedLateralItem ifNil: [^#()].

	^selectedLateralItem getExecutedArtifacts, selectedLateralItem getRunningArtifacts! !

!WAOrbeonProcessBrowser methodsFor: 'lateral assignment' stamp: 'BrunoBB 10/22/2015 16:17'!
getCurrentCollection

	searchApplied ifFalse: [^lateralCollection].

	^searchResult! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 12/10/2015 12:49'!
getFormDefinitionList
	| processName procDef |

	(searchValues includesKey: 'process-type') ifFalse: [^#()].

	processName := searchValues at: 'process-type'.

	procDef := self session user getProcessDefinitionNamed: processName.

	procDef ifNil: [^#()].

	^self viewAllArray, procDef getTaskNames asSet asSortedCollection! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 10/22/2015 16:17'!
getFormFieldList
	| fieldList definitions |

	definitions := OrbeonApplication formsDefinitionNamed: (searchValues at: 'form-type' ifAbsent: [^#()]).
	definitions isEmpty ifTrue: [^#()].
	fieldList := #(''), definitions last getFieldsNames.

	^(fieldList remove: 'k' ifAbsent: []; 
			remove: 's' ifAbsent: [];
			remove: 'oop' ifAbsent: [];
			remove: 'uuid' ifAbsent: [];
			yourself) asSortedCollection! !

!WAOrbeonProcessBrowser methodsFor: 'lateral assignment' stamp: 'BrunoBB 10/22/2015 16:17'!
getIconNameFormItem 

	^#pageprocess32Png! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 10/22/2015 16:17'!
getIterationCollection
	"Get the iteration collection where the search process will iterate over to find a specific element"

	(mode = #finished) ifTrue: [^self session user finishedAssignments asArray].

	^lateralCollection! !

!WAOrbeonProcessBrowser methodsFor: 'lateral assignment' stamp: 'BrunoBB 10/22/2015 16:17'!
getTextForItem: aLateralListItem

	^aLateralListItem processName! !

!WAOrbeonProcessBrowser methodsFor: 'orbeon links' stamp: 'BrunoBB 10/22/2015 16:17'!
getUrlFor: anOrbeonFormTransition with: anUUID
	"Generate an url link to Java Orbeon application with context execution parameters (that are stored as hidden in the Java Orbeon Form) so the Java Application can return back to this web page with an updated domain model"
	| formDefinition |

	formDefinition := anOrbeonFormTransition endFormName. "name of the form to link"
	^anOrbeonFormTransition hasForm "is a new or an edited form ?"
		ifFalse: [(anOrbeonFormTransition isGrantedUser: self session user) "has permissions ?"
					ifTrue: [self buildNewUrlFor: anOrbeonFormTransition with: anUUID]] "Orbeon NEW link"
		ifTrue: [(anOrbeonFormTransition isDone or:[(anOrbeonFormTransition isGrantedUser: self session user) not])
			ifFalse: [self buildEditUrlFor: anOrbeonFormTransition with: anUUID] "Orbeon EDIT link"
			ifTrue: [self buildViewUrlFor: anOrbeonFormTransition with: anUUID]] "Orbeon VIEW link"! !

!WAOrbeonProcessBrowser methodsFor: 'orbeon links' stamp: 'BrunoBB 10/22/2015 16:17'!
iconFor: anOrbeonFormTransition

	anOrbeonFormTransition isEndTransition ifTrue:[^#processacceptPng].
	anOrbeonFormTransition isCreated ifTrue: [^#pageprocess32Png].
	anOrbeonFormTransition isDone ifTrue: [^#pageaccept32Png].
	anOrbeonFormTransition isProcessing ifTrue: [^#documentediticonPng].
	anOrbeonFormTransition isPaused ifTrue: [^#stopwatchpausePng].
	anOrbeonFormTransition isDelayed ifTrue: [^#clockPng].
	anOrbeonFormTransition isPending ifTrue: [^#aquastrippedfolderclockPng].

	^#documentediticonPng! !

!WAOrbeonProcessBrowser methodsFor: 'orbeon links' stamp: 'BrunoBB 10/22/2015 16:17'!
imageTitleFor: anOrbeonFormTransition

	anOrbeonFormTransition isEndTransition ifTrue:[^'Finished Transition' translateFor: self session user].
	anOrbeonFormTransition isCreated ifTrue: [^'Create Form' translateFor: self session user].
	anOrbeonFormTransition isDone ifTrue: [^'Form Already Sent' translateFor: self session user].
	anOrbeonFormTransition isProcessing ifTrue: [^'Edit Form' translateFor: self session user].
	anOrbeonFormTransition isPaused ifTrue: [^'Paused' translateFor: self session user].
	anOrbeonFormTransition isDelayed ifTrue: [^'Delayed' translateFor: self session user].
	anOrbeonFormTransition isPending ifTrue: [^'Pending' translateFor: self session user].

	^'Undefined' translateFor: self session user! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 10/22/2015 17:29'!
initialize

	super initialize.

	searchAvailable := false.
	mode := #normal.
	categories := OrderedCollection new.
	transitionsHeight := Dictionary new.! !

!WAOrbeonProcessBrowser methodsFor: 'orbeon links' stamp: 'BrunoBB 10/22/2015 16:17'!
linkToOrbeonFormFor: anOrbeonFormTransition
	"The receiver gives the control to Orbeon Java application."

	self subclassResponsibility! !

!WAOrbeonProcessBrowser methodsFor: 'orbeon links' stamp: 'BrunoBB 10/22/2015 16:17'!
linkToOrbeonPdfFor: anOrbeonFormTransition
	| uuid |

		uuid  := OrbeonTempServiceRegistry default 
						createEntryToOrbeonFor: anOrbeonFormTransition 
						for: self session user.

		^self requestContext redirectTo: (self buildPDFUrlFor: anOrbeonFormTransition with: uuid)! !

!WAOrbeonProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 10/22/2015 16:17'!
mode
	^mode! !

!WAOrbeonProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 10/22/2015 16:17'!
mode: newValue
	"Set the mode of the receiver (#finished or #normal). 
	normal - is when lateral list is composed with current pending assignments.
	finished - is when lateral list is composed with finished assignments.
	If <mode> is different from <newValue> --> the sub menu has changed the <selectedLateralItem> must be reseted"

	(mode == newValue) ifFalse: [selectedLateralItem := nil].

	mode := newValue! !

!WAOrbeonProcessBrowser methodsFor: 'categories' stamp: 'BrunoBB 10/22/2015 16:17'!
onProcessCategoryClicked: aProcessInstanceUserCategory

	self hasSelectedLateralItem ifFalse: [^self filterProcessDefinitionByCategory: aProcessInstanceUserCategory].

	(aProcessInstanceUserCategory includes: selectedLateralItem)
	ifTrue: [aProcessInstanceUserCategory remove: selectedLateralItem]
	ifFalse: [aProcessInstanceUserCategory add: selectedLateralItem]! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 10/22/2015 16:17'!
registerProcessType: value

	searchValues at: 'process-type' put: value. 
	searchValues removeKey: 'form-type' ifAbsent: [].
	searchValues removeKey: 'field-name' ifAbsent: [].
	searchValues removeKey: 'field-value' ifAbsent: [].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 12/10/2015 12:38'!
renderApplicationComboOn: html

	html label 
		attributeAt: 'for' put: 'application';
		with: ('Application' translateFor: self session user).
	html select "Process Definition List"
		attributeAt: 'id' put: 'application';
		list: (#(''), (self session user getApplications collect: [:each | each app])) asSet asSortedCollection;
		onChange: 'submit()';
		callback: [:value | searchValues at: 'application' put: value];
		selected: (searchValues at: 'application' ifAbsent: ['']).! !

!WAOrbeonProcessBrowser methodsFor: 'categories' stamp: 'BrunoBB 10/22/2015 16:17'!
renderCategoriesListOn: html

	categories do: [:each | 
		html anchor callback: [self onProcessCategoryClicked: each]; 
			class: 'category-label';
			style: 'background-color:', each color;
			with: [html output: each name]].! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 10/22/2015 16:17'!
renderCloseAndSendFormOn: html for: anOrbeonFormTransition

	(anOrbeonFormTransition isGrantedUser: self session user) ifFalse: [^self].
	(anOrbeonFormTransition canCloseAndSend) ifFalse: [^self].

	html anchor callback: [self closeAndSendForm: anOrbeonFormTransition]; 
								with: [html image url: (SEWAFIconLibrary / #emailsendiconPng); 
														title: ('Close & Send Form' translateFor: self session user);
														altText: ('Close & Send Form' translateFor: self session user)]! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 10/22/2015 16:17'!
renderContentOn: html

	seasideK := self session requestContext request at: '_k' ifAbsent: ['error'].

	super renderContentOn: html.! !

!WAOrbeonProcessBrowser methodsFor: 'categories' stamp: 'BrunoBB 10/22/2015 16:17'!
renderCustomItemElementOn: html forItem: aOrbeonProcessDefinition

	(self session user getProcessInstanceCategoriesFor: aOrbeonProcessDefinition) do: [:each | 
		html div class: 'category-circle'; style: 'background-color: ', each color;
			with: [html output: each name first].
	].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 10/22/2015 16:17'!
renderFilterValuesAndButtonOn: html
	| processName procDef formType fieldName fieldType |

	((searchValues includesKey: 'field-name') and:[searchValues includesKey: 'form-type']) ifFalse: [^self renderSearchSubmitButtonOn: html].

	formType := searchValues at: 'form-type'.
	processName := searchValues at: 'process-type'.
	fieldName := searchValues at: 'field-name'.

	procDef := self session user getProcessDefinitionNamed: processName.

	procDef ifNil: [^self renderSearchSubmitButtonOn: html].

	fieldType := procDef getTypeOf: fieldName in: formType ifNone: [^self renderSearchSubmitButtonOn: html].

	(#('xf:boolean' 'xf:string' ) includes: fieldType) ifTrue: [^self renderOneFilterOn: html].

	^self renderTwoFitersOn: html.! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 10/22/2015 16:17'!
renderFormDataOn: html for: anOrbeonFormTransition

	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('User' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: anOrbeonFormTransition getUserName]].
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('State' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: (anOrbeonFormTransition printState translateFor: self session user)]].
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Previous Form' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: (anOrbeonFormTransition startFormName translateFor: self session user)]].
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Form to Fill' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: anOrbeonFormTransition endFormName]].
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Initial Date' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: anOrbeonFormTransition timeStamp]].
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Finished Date' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: anOrbeonFormTransition endTimeStamp]].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 10/22/2015 16:17'!
renderFormDefinitionComboOn: html

	html label 
		attributeAt: 'for' put: 'formDefinitions';
		with: ('Form' translateFor: self session user).

	html select "Form Definition List" 
		attributeAt: 'id' put: 'formDefinitions';
		class: 'search-section-width-200';
		list: ((searchValues includesKey: 'process-type') 
				ifFalse: [#()] 
				ifTrue: [self getFormDefinitionList]);
		onChange: 'submit()';
		callback: [:value | searchValues at: 'form-type' put: value];
		selected: (searchValues at: 'form-type' ifAbsent: ['']).! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 10/22/2015 16:17'!
renderFormFieldComboOn: html

	html label 
		attributeAt: 'for' put: 'formFields';
		with: ('Field' translateFor: self session user).

	html select "Field Definition List" 
		attributeAt: 'id' put: 'formFields';
		class: 'search-section-width-200';
		list: self getFormFieldList;
		onChange: 'submit()';
		callback: [:value | searchValues at: 'field-name' put: value];
		selected: (searchValues at: 'field-name' ifAbsent: ['']).! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 11/03/2015 11:51'!
renderItemComponentOn: html
	| heightClass |

	self getAllTransitions do:[:eachTransition | | transitionClass |
		transitionClass := eachTransition endNodeIsGateway 
			ifTrue: ['process-transition-gateway']
			ifFalse: [eachTransition isDone
				ifTrue: ['process-transition-finished']
				ifFalse: ['process-transition-running']].

		heightClass := ((transitionsHeight at: eachTransition ifAbsent: [#expanded]) = #expanded) 
								ifTrue: ['process-transition-expanded'] 
								ifFalse: ['process-transition-collapsed'].

		html div class: (transitionClass, ' ', heightClass); with: [
			self renderTransitionDataOn: html for: eachTransition].
	]. "end DO"! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 10/22/2015 16:17'!
renderItemDescriptionAditionalDataOn: html

	html span: [html strong: ('Version:' translateFor: self session user)]. 
	html output: selectedLateralItem version.
	html span: [html strong: ('Process State:' translateFor: self session user)].
	html output: (selectedLateralItem printProcessState translateFor: self session user).
	html span: [html strong: ('Process Creator:' translateFor: self session user)].
	html output: selectedLateralItem creator username.
	html span: [html strong: ('Can Unassign:' translateFor: self session user)]. 
	html output: (selectedLateralItem canUnassign printString translateFor: self session user).! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 12/10/2015 13:14'!
renderItemDescriptionSecondaryDataOn: html

	html span with: [html strong: ('Process Id:' translateFor: self session user)].
	html output: selectedLateralItem processId.
	html span with: [html strong: ('Assigned Date:' translateFor: self session user)].
	html output: selectedLateralItem printAssignmentDate.
	html span: [html strong: ('Current Forms:' translateFor: self session user)].
	html output: selectedLateralItem printRunningArtifacts.! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 12/10/2015 13:29'!
renderItemDescriptionTitleOn: html
	"The receiver render the summary of the object selected on the Lateral List "

	html output:  selectedLateralItem processName. "process name"
	selectedLateralItem isInCorruptedState 
	ifTrue: [html span with: [html strong: ('(Corrupted)' translateFor: self session user)]].

	selectedLateralItem hasFinalized
	ifFalse: [
		html anchor 
			callback: [self freeSelectedProcess]; 
			with: [html image url: (SEWAFIconLibrary / #gointo24Png); 
						title: ('Free Process' translateFor: self session user);
						altText: ('Free Process' translateFor: self session user)]].

	html anchor 
		callback: [self downloadProcessMap]; 
		with: [html image url: (SEWAFIconLibrary / #documentflowchart24Png); 
					title: ('Process Map' translateFor: self session user);
					altText: ('Process Map' translateFor: self session user)].! !

!WAOrbeonProcessBrowser methodsFor: 'lateral assignment' stamp: 'BrunoBB 12/10/2015 13:14'!
renderLateralItemDetailsOn: html for: aLateralItem

	html strong with: [html output: aLateralItem processId].
	html strong with: [html output: aLateralItem printAssignmentDate].
	html strong with: [html output: aLateralItem printRunningArtifacts]! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 10/22/2015 16:17'!
renderOneFilterOn: html

	html label 
		attributeAt: 'for' put: 'filterOne';
		class: 'search-section-float'; with: ('Field Value' translateFor: self session user).

	html textInput 
		attributeAt: 'id' put: 'filterOne';
		class: 'search-section-float search-section-width-200';
		callback: [:value | searchValues at: 'field-value' put: value];
		with: (searchValues at: 'field-value' ifAbsent: ['']).

	self renderSearchSubmitButtonOn: html.! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 10/22/2015 16:17'!
renderOrbeonLinkIconOn: html for: anOrbeonFormTransition

	"a granted user with edit permission"
	(anOrbeonFormTransition isGrantedUser: self session user) 
	ifTrue: [^self createOrbeonLinkOn: html for: anOrbeonFormTransition].
	"a user that has edit permission in other part of the process and does NOT has it this Transition, is granted to READ. 
	If the Form has not been created then there is NOTHING to view"
	((anOrbeonFormTransition hasReadAccess: self session user) and: [anOrbeonFormTransition hasForm]) ifTrue: [^self createOrbeonLinkOn: html for: anOrbeonFormTransition].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 12/10/2015 12:44'!
renderProcessTypeComboOn: html
	| definitionsNames |

	definitionsNames  := (BpmProcessDefinition getAllVersionsIn: (searchValues at: 'application' ifAbsent: [''])) collect: [:each | each processName].

	html label 
		attributeAt: 'for' put: 'processType';
		with: ('Process Type' translateFor: self session user).

	html select "Process Definition List"
		attributeAt: 'id' put: 'processType';
		list: self viewAllArray, definitionsNames
"(lateralCollection collect: [:each | each formProcessDefinition name]) asSet asSortedCollection";
		onChange: 'submit()';
		callback: [:value | self registerProcessType: value];
		selected: (searchValues at: 'process-type' ifAbsent: ['']).! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 10/22/2015 16:17'!
renderSearchAreaOn: html

	self searchPanelIsRegular ifTrue: [^self renderSearchRegularPanelOn: html].

	^self renderSearchCategoriesPanelOn: html! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 10/22/2015 16:17'!
renderSearchCategoriesPanelOn: html

	html form with: [ 
		html fieldSet with: [
			self renderSwitchWindowOn: html.
			html label attributeAt: 'for' put: 'categotyLabel'; with: ('Category Name' translateFor: self session user).
			html textInput attributeAt: 'id' put: 'categotyLabel'; callback: [:value | searchValues at: 'category-name' put: value].
			self renderCategoriesListOn: html.
			html div id: 'top-search-filters'; with: [
				html submitButton class: 'search-section-float search-section-width-100';
					callback: [self searchMatchingCategories]; 
					with: ('Search' translateFor: self session user).].
		].
].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 10/22/2015 16:17'!
renderSearchRegularPanelOn: html

	html form with: [ 
		html fieldSet with: [
			self renderSwitchWindowOn: html.
			html label attributeAt: 'for' put: 'processId'; with: ('Process Id' translateFor: self session user).
			html textInput attributeAt: 'id' put: 'processId'; callback: [:value | searchValues at: 'id' put: value].
			self renderApplicationComboOn: html.
			self renderProcessTypeComboOn: html.
			self renderFormDefinitionComboOn: html.
			self renderFormFieldComboOn: html.
			html div id: 'top-search-filters'; with: [
				"self renderTwoFitersOn: html."
				self renderFilterValuesAndButtonOn: html].
		].
]! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 10/22/2015 16:17'!
renderSearchSubmitButtonOn: html

	html submitButton 
		class: 'search-section-float search-section-width-100';
		callback: [self searchMatchingProcesses]; 
		with: ('Search' translateFor: self session user).! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 10/22/2015 16:17'!
renderSwitchWindowOn: html

	html div id: 'top-search-switch-icon'; with: [
		html anchor 
			callback: [searchPanelName := (searchPanelName = #search) ifTrue: [#categories] ifFalse: [#search]];
			with: [
				html div with: [
					html image url: (SEWAFIconLibrary / #ezswitchuser16Png); 
						altText: 'Switch Window'; 
						title: 'Switch Window'.
				].
		].
	].! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 10/22/2015 16:17'!
renderTransitionActionsOn: html for: anOrbeonFormTransition

	anOrbeonFormTransition endNodeIsGateway ifTrue: [^self].

	(anOrbeonFormTransition isSubprocessTransition not and: [anOrbeonFormTransition isEndTransition not])
		ifTrue: [self renderOrbeonLinkIconOn: html for: anOrbeonFormTransition].

	self renderCloseAndSendFormOn: html for: anOrbeonFormTransition.! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 10/22/2015 19:04'!
renderTransitionDataOn: html for: anOrbeonFormTransition

	html anchor class: 'process-transition-icon-collapse';
		callback: [self switchOpenCloseTransition: anOrbeonFormTransition]; 
		with: [html image url: (SEWAFIconLibrary / (self collapseIconFor: anOrbeonFormTransition));
								title: (self collapseTitleFor: anOrbeonFormTransition);
								altText: (self collapseTitleFor: anOrbeonFormTransition)].

	html header with: [html strong: anOrbeonFormTransition printFormLargeNameForWebButton].
	html header with: [html strong: ('Transition Data' translateFor: self session user)].

	((self displayModeFor: anOrbeonFormTransition) = #collapsed) ifTrue: [^self].

	anOrbeonFormTransition isFormTransition 
	ifTrue: [^self renderTransitionFormDataOn: html for: anOrbeonFormTransition].

	anOrbeonFormTransition isSubprocessTransition
	ifTrue: [^self renderTransitionSubProcessDataOn: html for: anOrbeonFormTransition].

	^self renderTransitionGatewayDataOn: html for: anOrbeonFormTransition! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 10/22/2015 19:01'!
renderTransitionFormDataOn: html for: anOrbeonFormTransition

	self renderFormDataOn: html for: anOrbeonFormTransition.

	self renderTransitionSummaryOn: html for: anOrbeonFormTransition.
	self renderTransitionActionsOn: html for: anOrbeonFormTransition.! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 10/22/2015 19:01'!
renderTransitionGatewayDataOn: html for: anOrbeonFormTransition

	anOrbeonFormTransition triggeredGateway ifNotNil: [:gateway |
		gateway outgoingTransitions do: [:transition |  
			html div class: 'transition-data'; with: [
				html strong with: [html span with: ('Condition' translateFor: self session user)].
				html strong with: [html output with: transition getStartConditionsString]].
			html div class: 'transition-data'; with: [
				html strong with: [html span with: ('Next Form' translateFor: self session user)].
				html strong with: [html output with: transition endFormName]].
		]
	].! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 10/22/2015 19:01'!
renderTransitionSubProcessDataOn: html for: anOrbeonFormTransition

	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('User' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: anOrbeonFormTransition getUserName]].
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('State' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: (anOrbeonFormTransition printState translateFor: self session user)]].
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Previous Form' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: (anOrbeonFormTransition startFormName translateFor: self session user)]].
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Form to Fill' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: anOrbeonFormTransition endFormName]].
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Initial Date' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: anOrbeonFormTransition timeStamp]].
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Finished Date' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: anOrbeonFormTransition endTimeStamp]].

	self renderTransitionSummaryOn: html for: anOrbeonFormTransition.
	self renderTransitionActionsOn: html for: anOrbeonFormTransition.! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 10/22/2015 16:17'!
renderTransitionSummaryOn: html for: anOrbeonFormTransition

	html header with: [html strong: (anOrbeonFormTransition summaryTitle translateFor: self session user)].

	anOrbeonFormTransition getSummaryFieldsValues keysAndValuesDo: [:key :value | 
		html div class: 'transition-data'; with: [
			html strong with: [html span with: key].
			html strong with: [html output with: value]]].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 10/22/2015 16:17'!
renderTwoFitersOn: html

	html label 
		attributeAt: 'for' put: 'filterOne';
		class: 'search-section-float'; 
		with: ('Start Value' translateFor: self session user).
	html textInput 
		attributeAt: 'id' put: 'filterOne';
		class: 'search-section-float search-section-width-200';
		callback: [:value | searchValues at: 'field-value' put: value];
		with: (searchValues at: 'field-value' ifAbsent: ['']).
	html label 
		attributeAt: 'for' put: 'filterTwo';
		class: 'search-section-float'; 
		with: ('End Value' translateFor: self session user).
	html textInput 
		attributeAt: 'id' put: 'filterTwo';
		class: 'search-section-float search-section-width-200';
		callback: [:value | searchValues at: 'field-value-2' put: value];
		with: (searchValues at: 'field-value-2' ifAbsent: ['']).

	self renderSearchSubmitButtonOn: html.! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 10/22/2015 16:17'!
searchByProcessId
	| id |

	id  := searchValues at: 'id' ifAbsent: [''].

	searchResult := self getIterationCollection select: [:each | each processId printString = id].

	selectedLateralItem := nil.
	"selectedTransition := nil."

	searchValues removeKey: 'id' ifAbsent: [''].! !

!WAOrbeonProcessBrowser methodsFor: 'categories' stamp: 'BrunoBB 10/22/2015 16:17'!
searchMatchingCategories

	categories := (ProcessInstanceUserCategory getCategoriesFor: self session user) select: [:each | 
		(searchValues at: 'category-name' ifAbsent: ['']) match: each name].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 10/22/2015 16:17'!
searchMatchingProcesses
	"Answer a collection of <OrbeonProcessAssignment> that match the search criteria in receiver's web interface.
	The fast search performed against a field name and a field value in a Form (<formName>, <fieldName> and <fieldValue>). 
	If these values are not specified then answer a collection of <OrbeonProcessAssignment> for the process name <procName> in application <appName>"
	| appName procName formName fieldName fieldValue |

	searchApplied := true.
	((searchValues includesKey: 'id') and:[(searchValues at: 'id') notEmpty]) ifTrue: [^self searchByProcessId].

	selectedLateralItem := nil.

	appName := searchValues at: 'application' ifAbsent: [''].
	procName := searchValues at: 'process-type' ifAbsent: [''].
	formName := searchValues at: 'form-type' ifAbsent: ['']. (formName = self viewAllText) ifTrue: [formName := ''].
	fieldName  := searchValues at: 'field-name' ifAbsent: [''].
	fieldValue  := searchValues at: 'field-value' ifAbsent: [''].

	(formName isEmpty and: [fieldName isEmpty and: [fieldValue isEmpty]]) 
	ifTrue: [^self getAllAssignmentsFor: procName in: appName].

	searchResult := OrbeonFormProcessDefinition getAssignmentsIn: appName processName: procName formName: formName fieldName: fieldName withValue: fieldValue.

	searchResult := (mode = #finished) 
		ifFalse: [searchResult reject: [:each | each isInEndTransition]] 
		ifTrue: [searchResult select: [:each | each isInEndTransition]]! !

!WAOrbeonProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 10/22/2015 16:17'!
seasideK
	^seasideK! !

!WAOrbeonProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 10/22/2015 16:17'!
seasideK: newValue
	seasideK := newValue! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 10/22/2015 18:35'!
selectedLateralItem: newValue
	| oldAssignment |

	oldAssignment := selectedLateralItem.
	selectedLateralItem := newValue.

	(newValue notNil and: [oldAssignment ~~ selectedLateralItem])
	ifTrue: [self setTransitionsHeight].! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 10/22/2015 18:28'!
setTransitionsHeight

	transitionsHeight := Dictionary new.

	self getAllTransitions do: [:each | 
		self session user transitionDisplayModeIsExpanded
		ifTrue: [transitionsHeight at: each put: #expanded]
		ifFalse: [transitionsHeight at: each put: #collapsed]].

	^transitionsHeight! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 10/22/2015 18:24'!
switchOpenCloseTransition: anOrbeonFormTransition

	((transitionsHeight includesKey: anOrbeonFormTransition) and: [(transitionsHeight at: anOrbeonFormTransition) = #expanded])
	ifTrue: [transitionsHeight at: anOrbeonFormTransition put: #collapsed]
	ifFalse: [transitionsHeight at: anOrbeonFormTransition put: #expanded]! !

SEWAFWebLogin subclass: #WAOrbeonProcessLogin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcessWeb2'!

!WAOrbeonProcessLogin methodsFor: 'other' stamp: 'BrunoBB 06/29/2015 16:54'!
style

	^'
h1 {margin-left: 20%;}
body {
	margin-bottom: 25px !!important;
	background-color: darkgrey;
}
#flags {
	float: right;
}
#flags img {
	margin-right: 5px;
}
#login {
	border-radius: 25px;
	padding-top: 20px;
	padding-bottom: 20px;
    width: 50%; 
    margin: 0 auto;
	background-color: lightblue;
}
#login form{
    width:50%;
	background-color: lightblue;
	margin-left: 20%;
}
#login form p{
	color: darkred;
}
#user {
	margin-bottom: 5px;
	display: inline-block;
	width: 80%;
}
#user input {
	border-radius: 15px;
	float: right;
}
#user label {
	float: left;
}
#password {
	display: inline-block;
	width: 80%;
}
#password label {
	float: left;
}
#password input {
	border-radius: 15px;
	float: right;
}
#login-button {
	float: right;
}
#login-button input {
	border-radius: 8px;
	margin-right: -20px;
}'! !

!WAOrbeonProcessLogin methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 09:44'!
tryLogin
	| logedUser |

	((OrbeonServerConfiguration default loginModeFor: 'orbeon-processes-web') validateUser: name password: password)
	ifFalse: [^loginAttempts := loginAttempts + 1].

	logedUser := BpmUser cache at: name.

	self session user: logedUser.

	"self show: (WAOrbeonFormUser on: logedUser)."

	self show: (WAProcessUserPortal on: logedUser).! !

SEWAFWebObjectComposite subclass: #FormProcessChangePasswordComposite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcessWeb2'!

!FormProcessChangePasswordComposite methodsFor: 'other' stamp: 'BrunoBB 06/05/2015 05:51'!
changePassword

	(self session user password = (searchValues at: 'current-pwd')) ifFalse: [^self inform: 'Invalid Current Password'].

	((searchValues at: 'repeat-new-pwd') = (searchValues at: 'new-pwd')) ifFalse: [^self inform: 'New Password and Repeat New Password must be equal.'].

	self session user password: (searchValues at: 'new-pwd').! !

!FormProcessChangePasswordComposite methodsFor: 'other' stamp: 'BrunoBB 07/24/2015 14:56'!
renderContentOn: html

	html div id: 'change-password'; class: 'unique-centered-form unique-centered-form-width38';
		with: [html form with: [
					html fieldSet with:[
						html legend with: [html strong: ('Change Password' translateFor: self session user)].
						html label attributeAt: 'for' put: 'currentPassword'; with: ('Current Password' translateFor: self session user).
						html textInput attributeAt: 'id' put: 'currentPassword'; callback: [:value | searchValues at: 'current-pwd' put: value].
						html label attributeAt: 'for' put: 'newPassword'; with: ('New Password' translateFor: self session user).
						html textInput attributeAt: 'id' put: 'newPassword'; callback: [:value | searchValues at: 'new-pwd' put: value].
						html label attributeAt: 'for' put: 'newPassword2'; with: ('Repeat New Password' translateFor: self session user).
						html textInput attributeAt: 'id' put: 'newPassword2'; callback: [:value | searchValues at: 'repeat-new-pwd' put: value].
						html submitButton callback: [self changePassword]; with: ('Confirm' translateFor: self session user).
					].
				].
		].! !

SEWAFWebObjectComposite subclass: #FormProcessUserPreferenceComposite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcessWeb2'!

!FormProcessUserPreferenceComposite methodsFor: 'other' stamp: 'BrunoBB 10/22/2015 18:51'!
renderContentOn: html

	html div id: 'user-preferences'; class: 'unique-centered-form unique-centered-form-width38';
		with: [html form with: [
					html fieldSet with:[
						html legend with: [html strong: ('Preferences' translateFor: self session user)].
						html output with: ('(true- embedded, false - in other page)' translateFor: self session user).
						html break.
						html checkbox 
							attributeAt: 'id' put: 'viewForm';
							callback: [:value | self session user orbeonWebIsLinked: value]; value: self session user orbeonWebIsLinked.
						html label attributeAt: 'for' put: 'viewForm'; with: ('View Form Embedded' translateFor: self session user).
						html break.
						html checkbox 
							attributeAt: 'id' put: 'transitionsDisplayModel';
							callback: [:value | self session user setTransitionsDisplayMode: value]; value: self session user transitionDisplayModeIsExpanded.
						html label attributeAt: 'for' put: 'transitionsDisplayModel'; with: ('Expanded Transitions Display Mode' translateFor: self session user).
						html submitButton callback: [self savePreferences]; with: ('Save Preferences' translateFor: self session user).
					].
				].
		].! !

!FormProcessUserPreferenceComposite methodsFor: 'other' stamp: 'BrunoBB 12/04/2014 04:17'!
savePreferences! !

SEWAFWebObjectComposite subclass: #UserLanguageComposite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcessWeb2'!

!UserLanguageComposite methodsFor: 'other' stamp: 'BrunoBB 06/26/2015 14:25'!
currentDictionaryName

	^searchValues at: 'selected-language' ifAbsent: ['']! !

!UserLanguageComposite methodsFor: 'other' stamp: 'BrunoBB 07/24/2015 15:04'!
renderContentOn: html

	html horizontalRule.

	html div id: 'internationalization'; class: 'unique-centered-form unique-centered-form-width38'; with: [
		html form with: [ 
			html fieldSet with: [
			html legend with: [html strong: ('Languages' translateFor: self session user)].
					html label attributeAt: 'for' put: 'language'; with: ('Select Language' translateFor: self session user).
					html select 
						attributeAt: 'id' put: 'language';
						class: '';
						list: (#(''), OrbeonInternationalization default currentDictionaries);
						callback: [:value | searchValues at: 'selected-language' put: value];
						selected: self session user currentLanguage.
					html submitButton 
						callback: [self setLanguage]; 
						with: ('Set Language' translateFor: self session user).
				].
		].
	].! !

!UserLanguageComposite methodsFor: 'other' stamp: 'BrunoBB 06/26/2015 14:25'!
setLanguage

	self session user setLanguage: self currentDictionaryName! !

SEWAFWebObjectComposite subclass: #WABpmUnassignedTaskBrowser
	instanceVariableNames: 'unassignedTask'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcessWeb2'!

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 12:44'!
hasSearchValueAt: aString

	^(self searchValueAt: aString)
		ifNotNil: [:each | each notEmpty]
		ifNil: [false]! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 09:26'!
initialize

	super initialize.

	unassignedTask := OrderedCollection new.! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 09:57'!
onApplicationChanged: appName

	searchValues at: 'application' put: appName! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 09:32'!
onRoleChanged: roleName

	searchValues at: 'role' put: roleName.! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 09:56'!
renderApplicationsComboOn: html

	html label attributeAt: 'for' put: 'applications'; with: ('Applications' translateFor: self session user).
	html select "Process Definition List"
		attributeAt: 'id' put: 'applications'; 
		list: (#(''), (self session user getApplications collect: [:each | each app])) asSortedCollection;
		callback: [:appName | self onApplicationChanged: appName];
		onChange: 'submit()';
		selected: (searchValues at: 'application' ifAbsent: ['']).! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 12:46'!
renderBpmTaskAssignment: aBpmTaskAssignment on: html 

	"self renderTakeTaskIconOn: html for: eachProcess."

		html div class: 'monitor-list-item-summary'; with: [
			html div class: 'monitor-list-item-data'; with: [
				html strong with: [html span: ('Process Id:' translateFor: self session user)].
				html output: aBpmTaskAssignment processId.].
			html div class: 'monitor-list-item-data'; with: [
				html strong with: [html span: ('Process Name:' translateFor: self session user)].
				html output: aBpmTaskAssignment processName.].
			html div class: 'monitor-list-item-data'; with: [
				html strong with: [html span: ('Creation Date:' translateFor: self session user)].
				html output: aBpmTaskAssignment creationDate.].
			html div class: 'monitor-list-item-data'; with: [
				html strong with: [html span: ('Task Name:' translateFor: self session user)].
				html output: aBpmTaskAssignment taskName.].
			html div class: 'monitor-list-item-data'; with: [
				html strong with: [html span: ('Role:' translateFor: self session user)].
				html output: aBpmTaskAssignment roleName.].
			self renderTakeTaskIconOn: html for: aBpmTaskAssignment.
		].! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 09:27'!
renderContentOn: html

	html horizontalRule.

	html div id: 'top-search-area'; with: [self renderSearchAreaOn: html.].

	html div id: 'free-tasks-list'; with: [self renderUnassignedTasksOn: html.].! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 10:01'!
renderRolesComboOn: html
	| roles appName |

	appName := searchValues at: 'application' ifAbsent: [''].
	roles := appName isEmpty
		ifFalse: [self session user roles select: [:each | each getApplicationName = appName] thenCollect: [:each | each name]]
		ifTrue: [#()].

	html label attributeAt: 'for' put: 'roles'; with: ('Roles' translateFor: self session user).
	html select "Process Definition List"
		attributeAt: 'id' put: 'roles'; 
		list: (#(''), roles) asSortedCollection;
		callback: [:roleName | self onRoleChanged: roleName];
		selected: (searchValues at: 'role' ifAbsent: ['']).! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 09:32'!
renderSearchAreaOn: html

	html form with: [ 
		html fieldSet with: [
			html div id: 'top-search-filters'; with: [
				self renderApplicationsComboOn: html.
				self renderRolesComboOn: html.
				self renderSearchSubmitButtonOn: html.
			].

			"html div id: 'top-search-filters'; with: [
				self renderFilterValuesAndButtonOn: html]."
		].
]! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 11:33'!
renderSearchSubmitButtonOn: html

	html submitButton 
		class: 'search-section-float search-section-width-100';
		callback: [self searchTasksAssignments]; 
		with: ('Search' translateFor: self session user).! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 12:11'!
renderTakeTaskIconOn: html for: aBpmTaskAssignment

	html div class: 'monitor-list-icon'; with: [
		html anchor callback: [self takeTask: aBpmTaskAssignment];
			with: [html image url: (SEWAFIconLibrary / #tasks32Png); 
						altText: 'Take Task';
						title: 'Take Task'].].! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 11:32'!
renderUnassignedTasksOn: html

	unassignedTask do: [:each | self renderBpmTaskAssignment: each on: html].! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 12:23'!
searchAll

	unassignedTask := self session user getAllAvailableTaskAssignments! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 12:45'!
searchTasksAssignments
	| matrix |

	((self hasSearchValueAt: 'application') and: [(self hasSearchValueAt: 'role')]) 
	ifTrue: [matrix := BpmRunningTasksMatrix getMatrixForApplicationNamed: (searchValues at: 'application').
				unassignedTask := matrix getAvailableTasksFor: (searchValues at: 'role').]
	ifFalse: [self searchAll].! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 13:10'!
takeTask: aBpmTaskAssignment

	self session user take: aBpmTaskAssignment! !

!WABpmUnassignedTaskBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 12/08/2015 09:25'!
unassignedTask
	^unassignedTask! !

!WABpmUnassignedTaskBrowser methodsFor: 'Updating' stamp: 'BrunoBB 12/08/2015 09:25'!
unassignedTask: newValue
	unassignedTask := newValue! !

SEWAFWebObjectComposite subclass: #WAFreeTransitionBagBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcessWeb2'!

!WAFreeTransitionBagBrowser methodsFor: 'other' stamp: 'BrunoBB 06/04/2015 11:23'!
checkIfProcessStillAvailable: anOrbeonFormProcess
	"Check if another user has taken the process already"

	^anOrbeonFormProcess checkIfStillAvailableFor: self session user! !

!WAFreeTransitionBagBrowser methodsFor: 'other' stamp: 'BrunoBB 06/04/2015 05:47'!
getFreeTransitions

	^OrbeonFormProcessDefinition getFreeTransitionsFor: self session user! !

!WAFreeTransitionBagBrowser methodsFor: 'other' stamp: 'BrunoBB 06/04/2015 06:10'!
getProcessWithFreeTransitions

	^self getFreeTransitions keys asArray! !

!WAFreeTransitionBagBrowser methodsFor: 'other' stamp: 'BrunoBB 07/24/2015 14:49'!
renderContentOn: html

	html horizontalRule.
	html div id: 'free-tasks-list'; with: [
		html unorderedList with:[
			self getProcessWithFreeTransitions do: [:eachProcess |
				html listItem with: [
					self renderFreeProcessOn: html for: eachProcess.
					html horizontalRule.].
				].
			].].! !

!WAFreeTransitionBagBrowser methodsFor: 'other' stamp: 'BrunoBB 11/06/2015 10:05'!
renderFreeProcessOn: html for: eachProcess

	self renderTakeTaskIconOn: html for: eachProcess.

	html div class: 'unique-wide-list-item-summary'; with: [
		html div class: 'unique-wide-list-item-data'; with: [
			html strong with: [html span: ('Process Id:' translateFor: self session user)].
			html output: eachProcess processId.].
		html div class: 'unique-wide-list-item-data'; with: [
			html strong with: [html span: ('Process Name:' translateFor: self session user)].
			html output: eachProcess name.].
		html div class: 'unique-wide-list-item-data'; with: [
			html strong with: [html span: ('Current Forms:' translateFor: self session user)].
			html output: eachProcess printRunningTransitions.].
		html div class: 'unique-wide-list-item-data'; with: [
			html strong with: [html span: ('Roles:' translateFor: self session user)].
			html output: eachProcess printCurrentRols.].
		html div class: 'unique-wide-list-item-data'; with: [
			html strong with: [html span: ('Creator:' translateFor: self session user)].
			html output: eachProcess creatorName.].
		html div class: 'unique-wide-list-item-data'; with: [
			html strong with: [html span: ('Creation Time:' translateFor: self session user)].
			html output: eachProcess createdTime.].].! !

!WAFreeTransitionBagBrowser methodsFor: 'other' stamp: 'BrunoBB 06/21/2015 16:38'!
renderTakeTaskIconOn: html for: anOrbeonFormProcess

	html div class: 'unique-wide-list-icon unique-wide-list-icon-height90'; with: [
		html anchor callback: [self takeTask: anOrbeonFormProcess];
			with: [html image url: (SEWAFIconLibrary / #tasks32Png); 
						altText: 'Take Task';
						title: 'Take Task'].].! !

!WAFreeTransitionBagBrowser methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 13:14'!
takeTask: anOrbeonFormProcess

	(self checkIfProcessStillAvailable: anOrbeonFormProcess) 
	ifFalse: [^self inform: 'Process [', 
						anOrbeonFormProcess processId printString, '] [', 
						anOrbeonFormProcess name, '] [',
						anOrbeonFormProcess printRunningArtifacts,'] - Has been already Taken by other user !!!!!!']. 

	^OrbeonProcessAssignment associateWithProcess: anOrbeonFormProcess for: self session user! !

SEWAFWebObjectComposite subclass: #WAOrbeonGrantedTransitionManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcessWeb2'!

!WAOrbeonGrantedTransitionManager methodsFor: 'other' stamp: 'BrunoBB 06/21/2015 16:52'!
renderContentOn: html

	html div id: 'granted-transitions'; class: 'unique-centered-table unique-centered-table-width70';
		with:[html render: self sewafTableForFormTransitionsDefinitions.].! !

!WAOrbeonGrantedTransitionManager methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 10:52'!
sewafTableForFormTransitionsDefinitions

	^(SewafSelectTableReport summary: 'Artifacts')
		rows: self session user getGrantedTasks; 
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #applicationName title: 'Application');
						add: (SewafReportColumn selector: #processDefinitionName title: 'Process');
						"add: (SewafReportColumn selector: #startFormName title: 'Required Form');"
						add: (SewafReportColumn selector: #name title: 'Form to Fill');
						add: (SewafReportColumn selector: #printRoleNames title: 'Roles');
						yourself);
		rowColors: #(white white);
		rowPeriod: 1;
		yourself! !

SEWAFWebObjectComposite subclass: #WAOrbeonNewProcessBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcessWeb2'!

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 13:07'!
createInstanceProcessFor: anBpmProcessDefinition
	"Create a new OrbeonFormProcess based on the definition OrbeonFormProcessDefinition <selectedDefinition> for the user <anOrbeonFormUser>.
	1- Create an OrbeonProcessAssignment.
	2- Create an OrbeonFormProcess.
	3- Associate the Assignment with the Process.
	4- The user <anOrbeonFormUser> take the assignment <anOrbeonProcessAssignment>"
	| processInstance |

	processInstance := anBpmProcessDefinition createAndStartProcessInstance: self session user.

	^processInstance! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 09:01'!
getAllFormProcessDefinition

	^self session user getCreationProcesses! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 07/24/2015 14:48'!
renderContentOn: html

	html horizontalRule.
	html div id: 'new-process-list'; with: [
		html unorderedList with:[
			self getAllFormProcessDefinition do: [:eachProcess |
				html listItem with: [
					self renderProcessDefinitionOn: html for: eachProcess.
					html horizontalRule.].
				].
			].].! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 08:53'!
renderNewProcessIconOn: html for: aBpmProcessDefinition

	html div class: 'unique-wide-list-icon unique-wide-list-icon-height75'; with: [
		html anchor callback: [self createInstanceProcessFor: aBpmProcessDefinition];
			with: [html image url: (SEWAFIconLibrary / #processadd32Png); 
						altText: ('Create New Process' translateFor: self session user);
						title: ('Create New Process' translateFor: self session user)].].! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 09:02'!
renderProcessDefinitionOn: html for: eachProcess

	self renderNewProcessIconOn: html for: eachProcess.

	html div class: 'unique-wide-list-item-summary'; with: [
		html div class: 'unique-wide-list-item-data'; with: [
			html strong with: [html span: ('Process Id:' translateFor: self session user)].
			html output: eachProcess processId.].
		html div class: 'unique-wide-list-item-data'; with: [
			html strong with: [html span: ('Process Name:' translateFor: self session user)].
			html output: eachProcess processName.].
		html div class: 'unique-wide-list-item-data'; with: [
			html strong with: [html span: ('Version:' translateFor: self session user)].
			html output: eachProcess version.].
		html div class: 'unique-wide-list-item-data'; with: [
			html strong with: [html span: ('Application:' translateFor: self session user)].
			html output: eachProcess applicationName.].
	].! !

SEWAFWebObjectComposite subclass: #WAOrbeonProcessCategoryManager
	instanceVariableNames: 'selectedCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcessWeb2'!

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 07/24/2015 14:45'!
categoryColorColumn

	^(SewafReportColumn 
			renderBlock: [:each :html | 
				html colorInput 
					attributeAt: 'title' put: ('Color' translateFor: self session user);
					value: each color.] 
			title: 'Color') sortBlock: nil; 
			yourself! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 06/30/2015 14:09'!
createNewCategory

	^model addToCacheIn: self session user username! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 07/02/2015 13:47'!
getAllUserCategories

	^ProcessInstanceUserCategory getCategoriesFor: self session user! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 06/30/2015 14:09'!
initialize

	super initialize.

	model := ProcessInstanceUserCategory new.! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 06/30/2015 14:09'!
modifyCategory

	selectedCategory removeFromCacheIn: self session user username.

	selectedCategory name: (self componentValueAt: 'name').
	selectedCategory color: (self componentValueAt: 'color').

	selectedCategory addToCacheIn: self session user username.! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 07/05/2015 13:11'!
removeCategory

	selectedCategory removeFromCacheIn: self session user username.

	selectedCategory := nil! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 07/24/2015 14:43'!
renderCategoryFormOn: html

	html form with: [
		html fieldSet with: [
			selectedCategory 
				ifNil: [
					html legend with: 'New Category'.
					html label attributeAt: 'for' put: 'categotyName'; with: 'Category Name'.
					html textInput attributeAt: 'id' put: 'categotyName'; callback: [:value | model name: value].
					html label attributeAt: 'for' put: 'color'; with: 'Color'.
					html colorInput attributeAt: 'id' put: 'color'; callback: [:value | model color: value].
					html submitButton callback: [self createNewCategory]; with: 'Create Category'.]
				ifNotNil: [
					html legend with: 'Selected Category'.
					html label attributeAt: 'for' put: 'categotyName'; with: 'Category Name'.
					html textInput 
						attributeAt: 'id' put: 'categotyName';
						value: selectedCategory name;
						callback: [:value | self addValue: value named: 'name'].
					html label attributeAt: 'for' put: 'color'; with: 'Color'.
					html colorInput 
						attributeAt: 'id' put: 'color';
						value: selectedCategory color; 
						callback: [:value | self addValue: value named: 'color'].
					html submitButton callback: [self modifyCategory]; with: 'Modify Category'.
					html submitButton callback: [self removeCategory]; with: 'Remove Category'.].].
			]! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 07/01/2015 12:58'!
renderContentOn: html

	html div id: 'top-search-area'; with: [self renderCategoryFormOn: html].

	html div class: 'unique-centered-table unique-centered-table-width30'; "id: 'user-categories';"
		with:[html render: self sewafTableForUserCategories.].! !

!WAOrbeonProcessCategoryManager methodsFor: 'Accessing' stamp: 'BrunoBB 06/30/2015 14:09'!
selectedCategory

   "Return the value of the instance variable 'selectedCategory'."
   ^selectedCategory! !

!WAOrbeonProcessCategoryManager methodsFor: 'Updating' stamp: 'BrunoBB 06/30/2015 14:09'!
selectedCategory: newValue

   "Modify the value of the instance variable 'selectedCategory'."
   selectedCategory := newValue! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 07/05/2015 13:01'!
sewafTableForUserCategories

	^(SewafSelectTableReport summary: 'User Process Categories')
		rows: self getAllUserCategories; "get collection elements"
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #name title: 'Category Name' onClick: 
						[:each | (selectedCategory == each) ifTrue: [selectedCategory := nil] ifFalse: [selectedCategory := each]]);
						add: self categoryColorColumn;
						yourself);
		selectedObject: selectedCategory;
		rowColors: #(white white);
		rowPeriod: 1;
		yourself! !

SEWAFApplicationPortal subclass: #WAProcessUserPortal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonFormProcessWeb2'!

!WAProcessUserPortal methodsFor: 'other' stamp: 'BrunoBB 06/27/2015 09:28'!
applicationIcon

	^SEWAFIconLibrary / #documentflowchart48Png! !

!WAProcessUserPortal methodsFor: 'other' stamp: 'BrunoBB 06/27/2015 09:29'!
applicationName

	^'Form Flow'! !

!WAProcessUserPortal methodsFor: 'other' stamp: 'BrunoBB 06/27/2015 09:23'!
getAssignmentComponentClassFor: anOrbeonFormUser
	"Answer the class to use to display User Process Assginments.
	- Can be linked (in a different web page of Smalltalk application).
	- Can be embedded (in the same we page of Smalltalk application)"

	anOrbeonFormUser userOptions orbeonWebIsLinked ifTrue: [^WALinkedProcessBrowser].

	^WAEmbeddedProcessBrowser! !

!WAProcessUserPortal methodsFor: 'other' stamp: 'BrunoBB 06/27/2015 09:23'!
initialize

	super initialize.

	subTabChanged := false.

	self initializeNavigation.! !

!WAProcessUserPortal methodsFor: 'top menu' stamp: 'BrunoBB 06/30/2015 14:02'!
initializeNavigation
	| subMenu1 subMenu2 subMenu3 subMenu4 |

	navigation := SewafPortalMenu new iconLibrary: SEWAFIconLibrary.
	subMenu1 := (SewafSubMenuItem label: 'My Processes' icon: #worksinprogress48Png)
		addItem: (SewafCommandItem label: 'Current Processes' command: #showCurrentProcess);
		addItem: (SewafCommandItem label: 'Finished Processes' command: #showFinishedProcess);
		addItem: (SewafCommandItem label: 'Process Categories' command: #showProcessCategories);
		yourself.
	subMenu2 := (SewafSubMenuItem label: 'Unassigned Tasks' icon: #folderscheduledtasks48Png)
		addItem: (SewafCommandItem label: 'View Unassigned Tasks' command: #showUnassignedTasks);
		yourself.
	subMenu3 := (SewafSubMenuItem label: 'Create Process' icon: #processadd48Png)
		addItem: (SewafCommandItem label: 'Available Processes' command: #showAvailableProcesses);
		addItem: (SewafCommandItem label: 'Granted Transitions' command: #showGrantedTransitions);
		yourself.
	subMenu4 := (SewafSubMenuItem label: 'User Preferences' icon: #applicationsettings48Png)
		addItem: (SewafCommandItem label: 'Change Password' command: #showChangePassword);
		addItem: (SewafCommandItem label: 'Form Display Mode' command: #showFormDisplayMode);
		addItem: (SewafCommandItem label: 'Set Language' command: #showLanguageConfiguration);
		yourself.
	navigation addItem: subMenu1;
		addItem: subMenu2;
		addItem: subMenu3;
		addItem: subMenu4.! !

!WAProcessUserPortal methodsFor: 'other' stamp: 'BrunoBB 06/27/2015 09:23'!
logout

	self session logout.	
	self session unregister.
	self requestContext redirectTo: (OrbeonServerConfiguration default gemstoneIP, '/orbeonProcess')! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 06/27/2015 09:23'!
showAvailableProcesses

	^WAOrbeonNewProcessBrowser new! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 06/27/2015 09:23'!
showChangePassword

	^FormProcessChangePasswordComposite new! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 12/10/2015 12:37'!
showCurrentProcess
	| subComponent |

	(arena isKindOf: WAOrbeonProcessBrowser)
	ifTrue: [
		(arena mode = #normal) ifFalse: [arena searchApplied: false].
		arena mode: #normal.
		^arena parent: self collection: self session user currentAssignments asArray].

	subComponent := (self getAssignmentComponentClassFor: self session user) 
				parent: self collection: self session user currentAssignments asArray.
	
	subComponent mode: #normal; searchApplied: false.

	^subComponent! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 07/06/2015 12:57'!
showFinishedProcess
	| subComponent |

	(arena isKindOf: WAOrbeonProcessBrowser)
	ifTrue: [
		(arena mode = #finished) ifFalse: [arena searchApplied: false].
		arena mode: #finished.
		^arena parent: self collection: OrderedCollection new"self session user finishedAssignments asArray"].

	subComponent := (self getAssignmentComponentClassFor: self session user) 
			parent: self collection: OrderedCollection new "self session user pendingAssignments asArray".

	subComponent mode: #finished; searchApplied: false.

	^subComponent! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 06/27/2015 09:23'!
showFormDisplayMode

	^FormProcessUserPreferenceComposite new! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 06/27/2015 09:23'!
showGrantedTransitions

	^WAOrbeonGrantedTransitionManager new! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 06/27/2015 09:23'!
showLanguageConfiguration

	^UserLanguageComposite new! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 07/05/2015 13:05'!
showProcessCategories

	(arena isKindOf: WAOrbeonProcessCategoryManager)
	ifTrue: [^arena].

	^WAOrbeonProcessCategoryManager parent: self! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 12/08/2015 08:46'!
showUnassignedTasks

	"^WAFreeTransitionBagBrowser new"

	(arena class == WABpmUnassignedTaskBrowser)
	ifFalse: [^WABpmUnassignedTaskBrowser new].

	^arena! !

!WAProcessUserPortal methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 17:25'!
style

^'/* Smart Devices*/
@media (max-width: 450px) {                  
   .smart-hide-width {
      display: none !!important;
   }
}
@media (max-height: 450px) {                  
   .smart-hide-height {
      display: none !!important;
   }
}
/* NEW CSS - REFACTORIZED */
/* START: HTML GENERAL */
body, html, main {
	margin: 0;
	width: 100%;
	height: 100%;
	overflow-y: hidden;
	background-color: #BCBCBC;
}
#screen-all {
	height: 100%;
}
/* END: HTML GENERAL */
/* START: TOP AREA */
#top-area {
	display: inline-flex;
	width: 100%;
	background-color: gray;
	padding-top: 2px;
}
#top-app-icon-area {
	display: inline-flex;
	padding-top: 15px;
	padding-left: 10px;
	width: 20%;
}
#top-app-icon-area h1{
	margin-top: 5px;
	color: gainsboro;
}
#top-logout a {
	text-decoration: none;
}
#top-logout output {
	font-size: 90%;
}
#top-menu-area {
	width: 80%;
	margin-top: 5px;
}
.top-menu-item {
	float: left;
	margin-left: 5%;
}
.top-menu-item a {
	color: white;
	text-decoration: none;
}
.top-menu-item a output {
	font-size: 120%;
}
.top-menu-item img {
	display: block;
	margin-left: auto;
	margin-right: auto;
}
.top-menu-item-triangle {
	border-style: solid;
	border-width: 0px 10px 10px;
	border-color: transparent transparent #D3D3D3;
	color: #FFF;
	width: 0px;
	height: 0px;
	margin-left: auto;
	margin-right: auto;
}
#top-submenu-area {
	height: 40px;
	background-color: lightgray;
}
.top-area-close-icon {
	float: right;
	margin-top: 3px;
	margin-right: 5px;
}
.top-sub-item-selected output {
	font-family: Times New Roman;
	font-size: 20px;
	color: rgb(64, 64, 64);
}
.top-sub-item-selected a, .top-sub-item-unselected a {
	text-decoration: none;
}
.top-sub-item-selected, .top-sub-item-unselected {
	float: left;
	padding-top: 10px;
	margin-left: 10px;
	margin-right: 30px;
}
.top-sub-item-unselected output {
	font-family: Times New Roman;
	font-size: 20px;
	color: #808080;
}
.top-sub-item-selected, .top-sub-item-unselected output:hover {
	color: rgb(64, 64, 64);
}
/* END: TOP AREA */
/* START: BOTTOM AREA */
/* END: BOTTOM AREA */
/* START: COMPONENT AREA */
#component-area {
	background-color: #BCBCBC;
	height: 100%;
}
#component-area hr {
	margin-top: 0px;
	margin-bottom: 0px;
}
/*START: SEARCH AREA*/
#top-search-area {
}
#top-search-switch-icon {
	display: inline-flex;
	float: right;
}
#top-search-area form fieldset {
	border-radius: 6px;
	margin-bottom: 0px;
	padding-bottom: 5px;
}
#top-search-area form fieldset label {
	margin-right: 10px;
}
#top-search-area form fieldset input[type="text"], select {
	border-radius: 6px;
	margin-right: 20px;
	border-color: darkgray;
	margin-top: 5px;
	margin-bottom: 5px;
}
#top-search-area form fieldset select {
	width: 20%;
}
#top-search-filters {
	display: inline;
}
#top-search-filters input {
	border-radius: 6px;
	margin-right: 20px;
	border-color: #A9A9A9;
}
/*END: SEARCH AREA*/
/*START: INNER COMPONENTS*/
.category-circle {
	width: 20px;
	height: 20px;
	border-radius: 10px;
	float: left;
	margin-bottom: 3px;
	margin-left: 2px;
	text-align: center;
}
.category-label {
	float: right;
	text-decoration: none;
	color: white;
	border-radius: 10px;
	padding-left: 5px;
	padding-right: 5px;
	margin-left: 5px;
	margin-right: 5px;
}
.free-selected-process {
	float: right;
}
#free-tasks-list {
	overflow-y: auto;
	height: 625px;
}
#free-tasks-list ul {
	list-style-type: none;
	margin-top: 0px;
}
.hide-lateral-left-list {
	float: left;
}
#item-customized-component {
	overflow-y: scroll;
	height: 60%;
}
.lateral-left-list {
	width: 20%;
	display: inline-block;
	overflow-y: scroll;
	height: 555px;
}
.lateral-left-list ul {
	list-style-type: none;
	padding-left: 2px;
}
.lateral-left-list a {
	text-decoration: none;
	color: black;
}  
.lateral-left-list ul li {
	margin-bottom: 10px;
}
.lateral-left-list-icon {
	width: 32px;
	float: left;
	padding-left: 5px;
	padding-top: 5px;
}
.lateral-left-list-item-selected {
	background-color: beige;
	border-radius: 10px;
	padding-left: 10px;
}
.lateral-left-list-item-unselected {
}
.lateral-left-list-item-summary-data {
	display: inline-block;
	color: rgb(37, 46, 146);
}
.lateral-left-list-item-summary-data output {
	display: block;
	margin-left: auto;
	margin-right: auto;
}
.lateral-left-list-item-title-selected {
	font-size: 150%;
}
.lateral-left-list-item-title-unselected {
	font-size: 150%;
}
.lateral-right-component-additional-data {
	text-align: center;
}
.lateral-right-component-additional-data span {
	font-style: italic;
	margin-right: 5px;
	margin-left: 15px;
	color: #8A8A59;
}
.lateral-right-component-additional-data output {
	color: darkblue;
}
.lateral-right-component {
	height: 100%;
	float: right;
	background-color: #BCBCBC;
}
.lateral-right-component-description {
	background-color: #E4E49E;
	padding-bottom: 15px;
}
.lateral-right-component-main-data {
	font-size: 150%;
	text-align: center;
}
.lateral-right-component-main-data a {
	float: right;
}
.lateral-right-component-width80 {
	width: 80%;
}
.lateral-right-component-width100 {
	width: 100%;
}
.lateral-right-component-secondary-data {
	text-align: center;
}
.lateral-right-component-secondary-data span {
	font-style: italic;
	margin-right: 5px;
	margin-left: 15px;
	color: #8A8A59;
}
.lateral-right-component-secondary-data output {
	color: darkblue;
}
.list-lateral-element {
	width: 90%;
}
.list-lateral-element-custom {
	float: right;
	width: 10%;
}
.list-lateral-item {
	display: flex;
	margin-bottom: 5px;
	margin-top: 5px;
}
.monitor-list-icon {
	width: 2.5%;
	float: left;
	display: inline;
}
.monitor-list-icon-height75 {
	height: 75px;
}
.monitor-list-icon-height90 {
	height: 110px;
}
.monitor-list-item-data {}
.monitor-list-item-data span {
	font-style: italic;
}
.monitor-list-item-data output {
	color: #231D81;
	margin-left: 10px;
	float: right;
}
.monitor-list-item-summary {
	display: inline-block;
    margin: 20px;
    padding: 20px;
    background-color: white;
    border-radius: 10px;
}
.monitor-list-item-summary span {
	font-style: italic;
}
#new-process-list  ul {
	list-style-type: none;
	margin-top: 0px;
}
#orbeon-form-frame {
	height: 400px;
} 
#orbeon-form {
	height: 100%;
}
#orbeon-form iframe {
	width: 100%;
	height: 100%;
}
#process-definition {
	height: 100%;
}
#process-assigment-transitions {
	margin-left: 10px;
	margin-top: 10px;
	overflow-y: auto;
	height: 440px;
}
.process-transition-icon-collapse {
	float: right;
}
.process-transition-finished {
	padding: 15px;
	padding-top: 5px;
	float: left;
	margin: 10px 10px 10px 10px;
	border-radius: 25px;
	background-color: #8CBD80;
	width: 28%;
	height: 60%;
	overflow-y: auto;
}
.process-transition-gateway {
	padding: 15px;
	padding-top: 5px;
	float: left;
	margin: 10px 10px 10px 10px;
	border-radius: 25px;
	background-color: #ADADAD;
	width: 28%;
	height: 60%;
	overflow-y: auto;
}
.process-transition-running {
	padding: 15px;
	padding-top: 5px;
	float: left;
	margin: 10px 10px 10px 10px;
	border-radius: 25px;
	width: 28%;
	height: 60%;
	overflow-y: auto;
	background-color: #80A0BD;
}
.process-transition-collapsed {
	height: 1%;
}
.process-transition-expanded {
	height: 60%;
}
.transition-data span {
	margin-right: 20px;
	font-style: italic;
	color: #565656;
    display: inline-table;
}
.transition-data output  {
	color: rgb(50, 51, 122);
	float: right;
}
.unique-centered-form {
	margin-left: auto;
	margin-right: auto;
	margin-bottom: 10px;
	padding-top: 20px;
}
.unique-centered-form-width38 {
	width: 38%;
}
.unique-centered-form form { 
	border-radius: 10px;
	border-style: inset;
	background-color: rgb(163, 187, 164);
	padding: 15px;
	border-width: 2px;
	width: 390px;
}
.unique-centered-form form fieldset {
	border: none;
} 
.unique-centered-form form input[type="text"]{ 
	border-radius: 10px;
	border-style: inset;
	width: 350px;
	margin-bottom: 5px;
}
.unique-centered-form form input[type="submit"] { 
	border-radius: 10px;
	width: 150px;
	border-right: 10px;
	margin-top: 10px;
}
.unique-centered-form form input[type="file"] { 
	border-radius: 10px;
	width: 400px;
	border-right: 10px;
	margin-top: 10px;
	margin-bottom: 5px;
}
.unique-centered-form form label { 
	display: block;
	margin-top: 10px;
}
.unique-centered-form form select { 
	border-radius: 10px;
	border-style: inset;
	display: block;
	width: 350px;
	margin-bottom: 10px;
}
.unique-centered-form form p { 
	margin-top: 10px;
	font-size: 20px;
	font-style: italic;
	text-align: right;
}
.unique-centered-table {
	margin-left: auto;
	margin-right: auto;
	border: 2px solid #000;
	border-radius: 10px;
	margin-top: 30px;

}
.unique-centered-table-width30 {
	width: 30%;
}
.unique-centered-table-width70 {
	width: 70%;
}
.unique-centered-table  table {
	width: 100%;
}
.unique-centered-table fieldset {
	border: 0px none;
	margin-left: auto;
	margin-right: auto;
	width: 150px;
	margin-top: 20px;
}
.unique-centered-table fieldset  input {
	border-radius: 10px
}
.unique-wide-list-icon {
	width: 2.5%;
	float: left;
	display: inline;
}
.unique-wide-list-icon-height75 {
	height: 75px;
}
.unique-wide-list-icon-height90 {
	height: 110px;
}
.unique-wide-list-item-data {}
.unique-wide-list-item-data span {
	font-style: italic;
}
.unique-wide-list-item-data output {
	color: #231D81;
	margin-left: 10px;
}
.unique-wide-list-item-summary {}
.unique-wide-list-item-summary span {
	font-style: italic;
}
/*END: INNER COMPONENTS*/
/* END: COMPONENT AREA */'! !
